<script setup lang="ts">
import { computed, onMounted } from 'vue'
import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/Employee'
import type { Salary } from '@/types/Salary'
import { useSalaryStore } from '@/stores/salary'
import { useUserStore } from '@/stores/user'

const userStore = useUserStore()
const salaryStore = useSalaryStore()

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'employee_Name',
    value: 'employee_Name'
  },
  {
    title: 'Bank Account',
    key: 'employee_BankAcc',
    value: 'employee_BankAcc'
  },
  {
    title: 'BaseSalary',
    key: 'baseSalary',
    // value: (item: Salary) => item.salary.toFixed(2)
    value: 'baseSalary'
  },
  {
    title: 'Increases',
    key: 'increaseSalary',
    // value: (item: Salary) => item.increases.toFixed(2),
    value: 'increaseSalary'
  },
  {
    title: 'Deducted',
    key: 'salaryReduc',
    // value: (item: Salary) => item.decreasess.toFixed(2)
    value: 'salaryReduc'
  },
  {
    title: 'Net.Salary',
    key: 'netSalary',
    // value: (item: Salary) => item.netSalary.toFixed(2)
    value: 'netSalary'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const receipt = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const search = ref('')
const alreadyDialog = ref(false)
const pendingDialog = ref(false)
const isEditing = ref(false)
const isAddNew = ref(true)
let myDate = new Date()
import { useAuthStore } from '@/stores/auth'
const authStore = useAuthStore()
let editedIndex = -1


function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}
async function deleteItemConfirm() {
  //Delete item from list

  closeDelete()
  await salaryStore.deleteSalary()
}

async function editItem(salary: Salary) {
  await salaryStore.getSalary(salary.id)
  console.log(salary)
  //call salaryDialog for update//
  // salaryDialogStore.doLoad()
  if (salary.status === 'Paid') {
    dialog.value = false
  } else {
    isEditing.value = true
    dialog.value = true
    isAddNew.value = false

  }
}
async function deleteItem(salary: Salary) {
  await salaryStore.getSalary(salary.id)
  dialogDelete.value = true
  editedIndex = -1
}
async function receiptSalary(salary: Salary) { //print receipt get salary
  // editedIndex = salarys.value.findIndex((s) => s.id === item.id)
  const editedSalary = await salaryStore.getSalary(salary.id)
  console.log(editedSalary)
  // await salaryStore.paySalary()
  const status = salaryStore.getStatusById(salary.id)
  // const id = employeeStore.getBankAccountById(salary.id)
  console.log(salaryStore.getStatusById(salary.id))
  if (status == 'Pending') {
    pendingDialog.value = true
  } else { //print slip
    salaryStore.getStatusById(salary.id)
    receipt.value = true
  }
}
const payDialog = ref(false)

async function confirmPay() { //comfirm to save
  payDialog.value = true
  // const index = editedSalary.value.id - 1
  // if (editedSalary.value.status === 'Unpaid') {
  //   editedSalary.value.status = 'Paid'
  //   salarys.value[index] = { ...editedSalary.value }
  //  
  // }
  salaryStore.editedSalary.status = 'Paid'
  await salaryStore.saveSalary()
  // await salaryStore.saveSalary()

  console.log(salaryStore.editedSalary.id)
  console.log(salaryStore.editedSalary.status)
  console.log(salaryStore.editedSalary)

  nextTick(() => {
    salaryStore.clearForm()
  })
  closePayDialog()
}

async function openPayDialog(salary: Salary) { // yes or no
  // editedIndex = salarys.value.indexOf(item)
  const editedSalary = await salaryStore.getSalary(salary.id)
  const status = await salaryStore.getStatusById(salary.id)
  console.log(status);
  console.log(salary)
  // editedSalary.value = Object.assign({}, item)
  if (status === 'Paid') {
    alreadyDialog.value = true
  } else {
    payDialog.value = true
    console.log(salary)
  }
}

function closePayDialog() {
  payDialog.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}

function closeAlreadyDialog() {
  alreadyDialog.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}

function closePendingDialog() {
  pendingDialog.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}
function onSubmit() { }

const page = ref(1)
const itemsPerPage = ref<any>(6)
const pageCount = computed(() => {
  return Math.ceil((filteredSalarys.value.length / itemsPerPage.value))
})
onMounted(async () => {
  await salaryStore.getSalarys()
  await userStore.getUsers()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  // if (isEditing.value == true) {
  //   isEditing.value = false
  // }
  closeDialog()
  // calNetSalary()
  await salaryStore.saveSalary()
}
async function saveEditItem() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  isEditing.value = false
  isAddNew.value = true
  closeDialog()
  // calNetSalary()
  await salaryStore.saveSalary()
}
function closeEditItemDialog() {
  dialog.value = false
  isEditing.value = false
  isAddNew.value = true
  nextTick(() => {
    salaryStore.clearForm()
  })
}
function closeReceipt() {
  receipt.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}

//for search
const formattedSalarys = computed(() => salaryStore.salarys.map((Salary) => ({ ...Salary })))
const tab = ref(null)
// const roleName = authStore.getCurrentUser()?.id

const filteredSalarys = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedSalarys.value.filter(
    (Salary) =>
      (Salary.status.toLowerCase().includes(searchLower) && (Salary.status == 'Paid'))
  )
})
const isEmployee = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Employee')
  }
  return false
})
</script>

<template>
  <div style="width: 95%">
    <!--dialog of new salary-->
    <div class="text-center">
      <h1 style="text-align: left; font-size: 50px;"><v-icon icon="mdi-account-cash" class="mr-2"></v-icon>Salary
      </h1>
    </div>
    <v-dialog v-model="dialog" persistent width="1024">
      <template v-slot:activator="{ props }">
        <v-card-title>
          <v-row>
            <v-col cols="12" sm="6">
              <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search"
                single-line flat hide-details variant="solo-filled"></v-text-field>
            </v-col>
            <v-col><v-btn color="success" v-bind="props"> New Salary </v-btn></v-col>
          </v-row>
        </v-card-title>
        <v-tabs v-model="tab" color="brown">
          <v-tab style="color: black" :to="{ name: 'salary' }">Total</v-tab>
          <v-tab style="color: black" :to="{ name: 'pending' }">Pending</v-tab>
          <v-tab style="color: black" :to="{ name: 'paid' }">Paid</v-tab>
          <v-tab style="color: black" :to="{ name: 'graph-salary' }">Summary</v-tab>
        </v-tabs>

        <v-data-table v-model:page="page" :headers="headers" :items="filteredSalarys">
          <template v-slot:bottom>
            <div class="text-center pt-2">
              <v-pagination v-model="page" :length="pageCount"></v-pagination>
            </div>
          </template>


          <template v-slot:[`item.payDate`]="{ value }">
            {{ value.toLocaleDateString('en-GB') }}
          </template>

          <template v-slot:[`item.status`]="{ item }">
            <div class="text-start">
              <v-chip :color="item.status === 'Paid' ? 'green' : 'red'" class="text-uppercase" label size="small">{{
      item.status === 'Paid' ? 'Paid' : 'Pending' }}
              </v-chip>
            </div>
          </template>

          <template v-slot:[`item.actions`]="{ item }">
            <!-- <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
                        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
                        <v-icon size="small" @click="openPayDialog(item)">mdi-cash </v-icon> -->
            <v-icon size="small" @click="receiptSalary(item)"> mdi-printer </v-icon>
          </template>
          <template v-slot:no-data>
            <v-btn color="primary" @click="salaryStore.getSalarys()">Reset</v-btn>
          </template>
        </v-data-table>

        <v-dialog v-model="dialogDelete" max-width="500px" persistent>
          <v-card>
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">you want to
              delete
              this
              info?
              🗑️</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeDelete">Cancel</v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="deleteItemConfirm">Delete</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <!--Bill-->
        <v-dialog v-model="receipt" persistent>
          <v-card :width="700" class="pa-6 mx-auto">
            <v-container>
              <v-row no-gutters>
                <v-col><v-img :width="85" src="./img/logo/logo1.jpg" class="image-position"></v-img></v-col>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-col cols="12" sm="12" md="4"></v-col>
                <v-col style="text-align: left" class="col" cols="12" sm="12" md="4">
                  Employee ID: {{ salaryStore.editedSalary.employee_Id }} <br />
                  Employee Name: {{ salaryStore.editedSalary.employee_Name }} <br />
                  Payment Date: {{ salaryStore.editedSalary.payDate }}
                </v-col>
                <v-col></v-col>
              </v-row>
              <v-row
                no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col>Income</v-col>
                <v-col>Amount</v-col>
                <v-col>Deducted</v-col>
                <v-col>Amount</v-col>
              </v-row>
              <v-row
                no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Salary</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.baseSalary.toFixed(2) }}
                  THB</v-col>
                <v-col style="font-size: small">Deducted</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.salaryReduc.toFixed(2) }}
                  THB</v-col>
              </v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Income</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.increaseSalary.toFixed(2) }}
                  THB</v-col>
                <v-col></v-col>
                <v-col></v-col>
              </v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Total Income :</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.netSalary.toFixed(2) }}
                  THB</v-col>
                <v-col style="font-size: small">Total Deducted :</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.salaryReduc.toFixed(2) }}
                  THB</v-col>
              </v-row>
              <v-row
                no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col></v-col>
                <v-col></v-col>
                <v-col>Total Receive :</v-col>
                <v-col class="emp" style="font-size: small">{{
      salaryStore.editedSalary.netSalary.toFixed(2) }}
                  THB</v-col>
              </v-row>
            </v-container>

            <!--Dialog printSlip-->
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3" @click="closeReceipt()">
                Cancel
              </v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeReceipt()">
                Print
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>


        <!--Delete Dialog-->
        <v-dialog v-model="dialogDelete" max-width="500px" persistent>
          <v-card>
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">you want to
              delete this
              info?
              🗑️</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeDelete">Cancel</v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="deleteItemConfirm">Delete</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <!--Pay Dialog-->
        <v-dialog v-model="payDialog" max-width="500px" persistent>
          <v-card>
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">you want to
              pay this info?
              🗑️</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px"
                @click="closePayDialog">Cancel</v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" @click="confirmPay">Pay</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <!--Already Pay-->
        <v-dialog v-model="alreadyDialog" max-width="500px" persistent>
          <v-card height="140px">
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">
              <v-icon>mdi-check-circle-outline</v-icon> This salary has been paid.
            </v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px"
                @click="closeAlreadyDialog">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>


        <!--Pending Dialog-->
        <v-dialog v-model="pendingDialog" max-width="500px" persistent>
          <v-card height="140px">
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">
              <v-icon>mdi-cancel</v-icon> This salary has not been paid.
            </v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px"
                @click="closePendingDialog">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
      <!--New Salary Dialog-->
      <v-card v-if="isAddNew" title="New Salary" class="pt-6" style="text-align: center">
        <v-card-title color="blue"> </v-card-title>
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <v-combobox :items="userStore.users" item-title="fullName" item-value="id" label="Name"
                    :return-object="true" variant="outlined" v-model="salaryStore.editedSalary.employee">
                  </v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="salaryStore.editedSalary.increaseSalary" :readonly="loading" suffix="THB" :rules="[
      (v: any) => !!v || 'Field is required',
      (v: number) => v >= 0 || 'Must be a non-negative number'
    ]" class="mb-2" clearable label="Increase" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="salaryStore.editedSalary.salaryReduc" :readonly="loading" suffix="THB" :rules="[
      (v: any) => !!v || 'Field is required',
      (v: number) => v >= 0 || 'Must be a non-negative number'
    ]" class="mb-2" clearable label="Reducted" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field v-model="myDate" :readonly="true" label="Payment Date"
                    variant="outlined"></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="red" @click="closeDialog()">
            Close
          </v-btn>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="success" @click="save()">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
      <!--isEditing-->
      <v-card v-if="isEditing" title="Update Salary" class="pt-6" style="text-align: center">
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <v-combobox :items="userStore.users" item-title="fullName" item-value="id" label="Name"
                    :return-object="true" variant="outlined" :readonly="true"
                    v-model="salaryStore.editedSalary.employee">
                  </v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="salaryStore.editedSalary.increaseSalary" :readonly="loading" suffix="THB" :rules="[
      (v: any) => !!v || 'Field is required',
      (v: number) => v >= 0 || 'Must be a non-negative number'
    ]" class="mb-2" clearable label="Increase" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="salaryStore.editedSalary.salaryReduc" :readonly="loading" suffix="THB" :rules="[
      (v: any) => !!v || 'Field is required',
      (v: number) => v >= 0 || 'Must be a non-negative number'
    ]" class="mb-2" clearable label="Reducted" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field v-model="myDate" :readonly="true" label="Payment Date"
                    variant="outlined"></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="red" @click="closeEditItemDialog()">
            Close
          </v-btn>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="success" @click="saveEditItem()">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}

.v-btn {
  width: 140px;
  height: 50px;
  color: white;
  font-family: Verdana, sans-serif;
}
</style>
